SystemOrganization addCategory: #SqueakSVNPlugins!

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: 'pool ctx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin class methodsFor: 'translation' stamp: 'rkrk 3/17/2008 03:40'!
declareCVarsIn: cg

	super declareCVarsIn: cg.
	"cg addHeaderFile: ' ---- squeakSVNWrapper.h -----'."
	cg
		var: 'pool' declareC: 'apr_pool_t *pool';
		var: 'ctx' declareC: 'svn_client_ctx_t *ctx'.
	cg
		addHeaderFile: '"svn_string.h"';
		addHeaderFile: '"svn_client.h"';
		addHeaderFile: '"svn_cmdline.h"';
		addHeaderFile: '"svn_pools.h"'.! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 13:26'!
cStringAllocatedOnHeapFromOop: aString
"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!Deprecated!!!!!!
Please do not allocate space on the heap anymore. Use Squeak objects instead.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"

	"Copied from OSProcessPlugin
	Free the result !!!!!!"

	"Answer a new null-terminated C string copied from aString. The C string
	is allocated from the C runtime heap. See transientCStringFromString for
	a version which allocates from object memory.
	Caution: This may invoke the garbage collector."

	| len sPtr cString |
	self returnTypeC: 'char *'.
	self var: 'sPtr' declareC: 'char *sPtr'.
	self var: 'cString' declareC: 'char *cString'.
	self var: 'len' declareC: 'size_t len'.
	sPtr := interpreterProxy arrayValueOf: aString.
	len := interpreterProxy sizeOfSTArrayFromCPrimitive: sPtr.
	cString := self callocWrapper: len + 1 size: 1.			"Space for a null terminated C string."
	self
		cCode: '(char *) strncpy (cString, sPtr, len)';	"Copy the string."
		cCode: 'cString[len] = ''\0'''.	"Terminate with null"
	^ cString! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 10:37'!
cStringFromOop: stringOop

	| stringPtr |
	self returnTypeC: 'const char *'.
	self var: #stringPtr declareC: 'char* stringPtr'.
	
	stringPtr :=  interpreterProxy arrayValueOf: stringOop.
	stringPtr at: (interpreterProxy stSizeOf: stringOop) put: (self cCode: '''\0''').
	^ stringPtr! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 3/13/2008 22:51'!
callocWrapper: count size: objectSize
	"Copied from OSProcessPlugin"
	"Using malloc() and calloc() is something I would like to avoid, since it is
	likely to cause problems some time in the future if somebody redesigns
	object memory allocation. This wrapper just makes it easy to find senders
	of calloc() in my code. -dtl"

	self returnTypeC: 'void *'.
	^ self cCode: 'calloc(count, objectSize)'! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 11:14'!
convertCStringToOop: aCString
	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| len newString |
	self var: 'aCString' type: 'const char *'.
	len := self strlen: aCString.
	"self convertToOopCString: aCString ofSize: len."
	newString := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: len.
	self st: (interpreterProxy arrayValueOf: newString)
		rn: aCString
		cpy: len. "(char *)strncpy()"
	^ newString! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 11:15'!
convertToOopCString: cString ofSize: len
	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| stringOop |
	self
		var: #cString type: 'const char *';
		var: #len 	type: 'size_t'.
	
	"self
		writeTextToOutputFile: 'convertCStringOfSize:toOop:. Copy String:';
		writeTextToOutputFile: cString;
		writeTextToOutputFile: 'convertCStringOfSize:toOop: of size:';
		writeIntToOutputFile: (self strlen: cString);
		writeTextToOutputFile: 'convertCStringOfSize:toOop: to size:';
		writeIntToOutputFile: len."
	
	stringOop := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: len.

	0 to: len - 1 do: [:i |
		self print: '%c\n' f: (cString at: i).
		(self cCoerce: (interpreterProxy arrayValueOf: stringOop) to: 'char *') at: i put: (cString at: i)
		"self me: ((interpreterProxy arrayValueOf: stringOop) at: i) mc: (cString at: i) py: (self cCode: 'sizeOf(char)')"].
	(self cCoerce: (interpreterProxy arrayValueOf: stringOop) to: 'char *') at: len put: (self cCode: '''\0''').
	"0 to: len - 1 do: [:i |
		stringPtr at: len put: (cString at: i)]."
	"stringPtr at: len put: (self cCode: '''\0''')."
	"self myStr: (interpreterProxy arrayValueOf: newString) n: len cpy: cString."
	self
		writeTextToOutputFile: 'convertCStringOfSize:toOop: stringOop';
		writeTextToOutputFile:  (interpreterProxy arrayValueOf: stringOop);
		writeTextToOutputFile: 'convertCStringOfSize:toOop: Size';
		writeIntToOutputFile: (self strlen: (interpreterProxy arrayValueOf: stringOop)).
		
	^ stringOop! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rkrk 3/20/2008 03:07'!
copyKeyAndValueOfAprHashIndex: hi in: arrayOop at: i
	
	|  propkey key propval value keyLen newCString |
	self
		var: #hi 			type: 'apr_hash_index_t *';
		var: #arrayOop  	type: 'sqInt';
		var: #i 			type: 'int';
		var: #key 		declareC: 'const void *key';
		var: #keyLen 		declareC: 'apr_ssize_t keyLen';
		var: #value 		declareC: 'void *value';
		var: #propkey 	declareC: 'const char *propkey';
		var:  #propval	declareC: 'svn_string_t *propval';
		var: #newCString  declareC: 'const char *newCString'.
		
	self cCode: 'apr_hash_this(hi, &key, &keyLen, &value)'.
	propkey := self cCoerce: key to: 'const char *'.
	propval := self cCoerce: value to: 'svn_string_t *'.

	self writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: ---------------------BEGIN------------------------'.
	interpreterProxy
		storePointer: i
		ofObject: arrayOop
		withValue: (self
			convertToOopCString: propkey
			ofSize: keyLen).
	"interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: i ofObject: arrayOop)
	goes beyond the size of the char* in newSqueakString. Is this a problem?"
	interpreterProxy
		storePointer: i + 1
		ofObject: arrayOop
		withValue: (self
			convertToOopCString: (self cCode: 'propval->data')
			ofSize: (self cCode: 'propval->len')).
	
	"for debug output only"
	newCString := interpreterProxy arrayValueOf: (interpreterProxy
							fetchPointer: i
							ofObject: arrayOop).

	"self
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at:';
		writeTextToOutputFile: newCString;
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- size:';
		writeIntToOutputFile: (self strlen: newCString);
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- expected size:';
		writeIntToOutputFile: keyLen."
		"writeTextToOutputFile: (interpreterProxy arrayValueOf: (arrayPtr at: i+1));
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- size:';
		writeIntToOutputFile: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i +1)));
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- expected size:';
		writeIntToOutputFile: (self cCode: 'propval->len')."

	"description: '#convertCStringOfSize:toOop: has failed'."
	"self assert: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i))) = keyLen.
	self assert: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i + 1))) = (self cCode: 'propval->len')."! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'rkrk 3/16/2008 23:16'!
initialiseModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  initialize of SqueakSVNPlugin'.
	self
		cCode: 'initialize(&pool, &ctx)';
		cCode: 'authenticate(&pool, &ctx)'.
	self writeTextToOutputFile: 'Initialize  of SqueakSVNPlugin complete'.
	^ true
! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 01:35'!
myStr: destination n: size cpy: source

	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| newString |
	self
		var: 'destination' type: 'char *';
		var: 'source' type: 'const char *';
		var: 'size' type: 'size_t'.
	
	self
		writeTextToOutputFile: 'myStrncpy: Copy String:';
		writeTextToOutputFile: source;
		writeTextToOutputFile: 'myStrncpy: To size';
		writeIntToOutputFile: size.
		
	0 to: size - 1 do: [:i |
		destination at: i put: (source at: i)].
	destination at: size put: (self cCode: '''\0''').
	self
		writeTextToOutputFile: 'myStrncpy: destination';
		writeTextToOutputFile:  destination;
		writeTextToOutputFile: 'myStrncpy: Size';
		writeIntToOutputFile: (self strlen: (destination)).
		
	^ newString! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/14/2008 01:50'!
onlyATest

	| result |
	self export: true.
	self var: #result declareC: 'char *result'.
	result := self test.
	interpreterProxy
		pop: 1
		thenPush: (self convertCStringToOop: result).! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 17:35'!
putAprDate: date in: arrayPtr at: index

	| dateString|
	self
		var: #index type: 'int';
		var: #date type: 'apr_time_t';
		var: #arrayPtr type: 'sqInt **';
		var: #dateString declareC: 'char dateString[APR_CTIME_LEN] '.

	date = nil ifTrue: [^ nil].
	self cCode: 'apr_ctime(dateString, date)'.
	self putCString: dateString in: arrayPtr at: index.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 16:47'!
putCString: cstring in: arrayPtr at: index

	| stringOop |
	self
		var: #cstring type: 'const char *';
		var: #index type: 'int';
		var: #arrayPtr type: 'sqInt**'.
	self	var: #stringOop declareC: 'sqInt stringOop'.

	cstring = nil ifTrue: [^ nil].
	self writeTextToOutputFile: cstring.
	stringOop := self convertCStringToOop: cstring.
	self cCode: '(*arrayPtr)[index] = stringOop'.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 16:58'!
putRevision: revision in: arrayPtr at: index

	| revisionOop |
	self
		var: #index type: 'int';
		var: #revision type: 'svn_revnum_t';
		var: #arrayPtr type: 'sqInt **';
		var: #revisionOop declareC: 'sqInt revisionOop'.

	revision = nil ifTrue: [^ nil].
	self writeIntToOutputFile: revision.
	
	revisionOop := interpreterProxy integerObjectOf: revision.
	self cCode: '(*arrayPtr)[index] = revisionOop'.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 21:34'!
putSchedule: schedule in: arrayPtr at: index

	self
		var: #index type: 'int';
		var: #schedule type: 'svn_wc_schedule_t';
		var: #arrayPtr type: 'sqInt **'.

	self writeIntToOutputFile: schedule.
	schedule = nil ifTrue: [^ nil].
	(self cCode: 'schedule == svn_wc_schedule_normal' ) 	ifTrue: [self putCString: 'normal' 	in: arrayPtr at: index.].
	(self cCode: 'schedule == svn_wc_schedule_add' )		ifTrue: [self putCString: 'add' 		in: arrayPtr at: index.].
	(self cCode: 'schedule == svn_wc_schedule_delete' )		ifTrue: [self putCString: 'delete' 	in: arrayPtr at: index.].
	(self cCode: 'schedule == svn_wc_schedule_replace' )	ifTrue: [self putCString: 'replace' 	in: arrayPtr at: index.].! !

!SqueakSVNPlugin methodsFor: 'shutdown' stamp: 'rkrk 3/17/2008 04:06'!
shutdownModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  shutdown of SqueakSVNPlugin'.
	"Free the apr memory pool"
	self cCode: 'freeMemory(&pool)'.
	
	self writeTextToOutputFile: 'Shutdown of SqueakSVNPlugin complete'.
	^ true! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 20:46'!
sizeForSvnInfoArray

	^ 12! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rkrk 3/20/2008 02:11'!
squeakArrayFromAprHash: aprHash

	| arrayOop i hi arraySize |
	self
		var: #aprHash 		type: 'apr_hash_t *';
		var: #hi				declareC:  'apr_hash_index_t *hi';
		var: #arraySize 		declareC: 'size_t arraySize';
		var: #i 				declareC: 'int i'.

	self writeTextToOutputFile: '#squeakArrayFromAprHash: Properties read. Copying...'.
	
	"Store key and values in an array. Therefore this array
	must have twice the size of the hash table"
	arraySize := self cCode: '2 * apr_hash_count(aprHash)'.
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: arraySize.
	
	i := 0.
	hi := self cCode: 'apr_hash_first(pool, aprHash)'.
	[hi] whileTrue: [
		self
			copyKeyAndValueOfAprHashIndex: hi
			in: arrayOop
			at: i.
		i := i + 2. "Store both key and value in array"
		hi := self cCode: 'apr_hash_next(hi)'].
	self writeTextToOutputFile: '#squeakArrayFromAprHash: Finished copying properties'.
	^ arrayOop! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/12/2008 13:25'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/20/2008 04:33'!
stringTest02

	| oop ptr aString |

	self export: true.
	self
		"var: #aString declareC: 'char aString[] = /Users/robertkrahn/squeak/squeakSVN/images/svnTests/SVNAwareTestDirectory_71/workingCopy';"
		var: #aString declareC: 'char aString[] = "Haloo"';
		var: #ptr 	declareC: 'char *ptr'.
	
	aString at: 3 put: (self cCode: '''\0''').
	self	writeIntToOutputFile: (self strlen: aString).
	oop := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: (self strlen: aString).
	0 to: (self strlen: aString) - 1 do: [:i |
		self print: '%c\n' f: (aString at: i).
		(self cCoerce: (interpreterProxy arrayValueOf: oop) to: 'char *') at: i put: (aString at: i)].
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: oop).
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'rkrk 3/20/2008 10:20'!
svnAdd: targetOop

	| target |
	self export: true.
	self var: #target declareC: 'char *target'.
	self primitive: 'svnAdd' parameters: #(Oop ).
	
	target := self cStringAllocatedOnHeapFromOop: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'addTargetToWC (target)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	^targetOop! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rkrk 3/20/2008 16:08'!
svnAddProperty: propertyOop WithValue:valueOop To: targetOop

	| property value target |
	self export: true.
	self var: #property declareC: 'char *property'.
	self var: #value declareC: 'char *value'.
	self var: #target declareC: 'char *target'.
	self primitive: 'svnAddPropertyWithValueTo' parameters: #(Oop Oop Oop).
	
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Entered'.
	property := self cStringAllocatedOnHeapFromOop: propertyOop.
	value := self cStringAllocatedOnHeapFromOop: valueOop.
	target := self cStringAllocatedOnHeapFromOop: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'addPropertyAndValueToTarget (property, value, target)'.
	
	self cCode: 'free(property)'.
	self cCode: 'free(value)'.
	self cCode: 'free(target)'.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/20/2008 16:11'!
svnAlternativeGetHeadRevision: targetOop

	| resultArray arrayPtr revision target truepath err pegRevision|
	self export: true.
	self
		var: #arrayPtr 		declareC: 'sqInt* arrayPtr';
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #pegRevision 	declareC: 'svn_opt_revision_t pegRevision';
		var: #target 			declareC: 'const char *target';
		var: #truepath 		declareC: 'char *truepath';
		var: #err 			declareC: 'svn_error_t *err'.
	self primitive: 'svnAlternativeGetHeadRevision' parameters: #(Oop).

	self writeTextToOutputFile: '#svnAlternativeGetHeadRevision: Entered'.
	
	target := interpreterProxy arrayValueOf: targetOop.
	
	resultArray := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: self sizeForSvnInfoArray.
	arrayPtr := interpreterProxy firstIndexableField: resultArray.
	
	arrayPtr. revision. target. truepath. pegRevision.
	
	self cCode: 'svn_opt_parse_path(&pegRevision, &truepath, target, pool)'.
	self cCode: 'pegRevision.kind = svn_opt_revision_unspecified'.
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.
	"self cCode: 'revision.value.number = 7'."
	err := self cCode: 'svn_client_info (
		truepath,
		&pegRevision, 					/* peg-revision */
		&revision, 						/* revision ???? */
		svnInfoCbBatonTargetInfoPool,		/* callback */
		(void*) &arrayPtr, 				/* baton */
		FALSE, 							/* no recurse */
		ctx, pool)'.
	err ifTrue: [self handleError: err].
	
	^ resultArray! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'rkrk 3/20/2008 16:08'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop

	| url path |
	self export: true.
	self var: #url declareC: 'char* url'.
	self var: #path declareC: 'char* path'.
	self primitive: 'svnCheckoutHeadRevisionFromTo' parameters: #(Oop Oop ).
	
	self writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Entered'.
	
	url := self cStringAllocatedOnHeapFromOop: aURLOop.
	path := self cStringAllocatedOnHeapFromOop: aPathOop.
	
	"Call SVNWrapper function"
	self cCode: 'checkoutHeadRevisionFormTo(url, path)'.
	
	self cCode: 'free(url)'.
	self cCode: 'free(path)'! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'rkrk 3/20/2008 16:09'!
svnCheckoutRevisionByNumber: aNumberOop from: aURLOop to: aPathOop

	| revisionNumber url path |
	self export: true.
	self var: #revisionNumber declareC: 'long int revisionNumber'.
	self var: #url declareC: 'char* url'.
	self var: #path declareC: 'char* path'.
	self primitive: 'svnCheckoutRevisionByNumberFromTo' parameters: #(Integer Oop Oop ).
	
	"self cCode: 'revisionNumber = (long int) aNumberOop'."
	self writeTextToOutputFile: '#svnCheckoutRevisionByNumber:from:to Entered'.
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	url := self cStringAllocatedOnHeapFromOop: aURLOop.
	path := self cStringAllocatedOnHeapFromOop: aPathOop.
	
	"Call SVNWrapper function"
	self cCode: 'checkoutRevisionByNumberFormTo(revisionNumber, url, path)'.
	
	self cCode: 'free(url)'.
	self cCode: 'free(path)'! !

!SqueakSVNPlugin methodsFor: 'svn cleanup' stamp: 'rt 3/20/2008 14:06'!
svnCleanupDirectory: directory

	| dir err |
	self export: true.
	self 
		var: #dir	declareC: 'char* dir';
		var: #err 	declareC: 'svn_error_t *err'.
	self primitive: 'svnCleanupDirectory' parameters: #(Oop).
	
	self writeTextToOutputFile: 'Entered cleanup'.
	
	
	dir := self cStringFromOop: directory.
	
	self writeTextToOutputFile: dir.
	err := self cCode: 'svn_client_cleanup(
		dir,
		ctx,
		pool)'.
	err ifTrue: [self handleError: err].
	
	self writeTextToOutputFile: 'Leave cleanup'.
	^directory! !

!SqueakSVNPlugin methodsFor: 'svn commit' stamp: 'rkrk 3/20/2008 16:10'!
svnCommit: aOopCollectionOfOopTargets WithMessage: aOopMessage

	| targetsArray squeakStrings count cString message |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self var: #message declareC: 'char* message'.
	self primitive: 'svnCommitWithMessage' parameters: #(Oop Oop).
	
	"convert the collection"
	self writeTextToOutputFile: '#svnCommit:WithMessage: Entered'.
	
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	message := self cStringAllocatedOnHeapFromOop: aOopMessage.
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'commit( count, targetsArray, message)'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.
	self cCode: 'free( message )'.! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'rkrk 3/20/2008 10:22'!
svnDeleteTargetsFromWorkingCopy: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self primitive: 'svnDeleteTargetsFromWorkingCopy' parameters: #(Oop).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'deleteTargetsFromWC( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.
	
	^aOopCollectionOfOopTargets! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/20/2008 16:11'!
svnGetBlameLinesFrom: targetOop
	"returns an array like #(rev1 author1 date1 line1 ...)"
	
	| target cArray arrayOop ptr numberOfLines |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #cArray declareC: 'char **cArray'.
	self var: #numberOfLines declareC: 'int numberOfLines'.
	self var: #ptr declareC: 'int *ptr'.
	self primitive: 'svnGetBlameLinesFrom' parameters: #(Oop).
	
	target := self cStringAllocatedOnHeapFromOop: targetOop.
	
	self writeTextToOutputFile: '#svnGetBlameLinesFrom: Entered'.
	"get the filled array"
	self cCode: 'getBlameLines(target, &numberOfLines, &cArray)'.

	"Create a Squeak-Array in which the result can be returned"
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: numberOfLines.
	
	"Copy the entries into the Squeak-Array and free them"
	ptr := interpreterProxy firstIndexableField: arrayOop.
	0 to: numberOfLines - 1 do: [:i |
		ptr at: i put: (self convertCStringToOop: (cArray at: i)).
		self free: (cArray at: i)].
	self free: cArray.
	
	^ arrayOop.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'mu 3/20/2008 18:32'!
svnGetCommitLogFrom: targetOop to: headRevisionNumberOop 
	| arrayOop ptr target logOop pegRevisionNumber startRevisionNumber endRevisionNumber revisionAndLogArray arraySize |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #pegRevisionNumber declareC: 'long int pegRevisionNumber'.
	self var: #startRevisionNumber declareC: 'long int startRevisionNumber'.
	self var: #endRevisionNumber declareC: 'long int endRevisionNumber'.
	self var: #revisionAndLogArray declareC: 'char **revisionAndLogArray'.
	self var: #arraySize declareC: 'size_t arraySize'.
	self var: #ptr declareC: 'int *ptr'.
	
	self primitive: 'svnGetCommitLogFromTo'
		parameters: #(#Oop #Integer ).
	
	self writeTextToOutputFile: '#svnGetCommitLogFromTo: Entered'.
	target := self cStringAllocatedOnHeapFromOop: targetOop.
	pegRevisionNumber := 0.
	startRevisionNumber := 0.
	endRevisionNumber := interpreterProxy integerValueOf: headRevisionNumberOop.
	
	self cCode: 'getCommitLog(target, pegRevisionNumber, startRevisionNumber, endRevisionNumber, &revisionAndLogArray, &arraySize)'.
	
	"Create a Squeak-Array in which the result can be returned"
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: arraySize.
	
	"Copy the entries into the Squeak-Array and free them"
	ptr := interpreterProxy firstIndexableField: arrayOop.
	"self writeTextToOutputFile: 'Before copying array'."
	arraySize ~= 0 
		ifTrue: [0 to: arraySize - 1 do: [:i |
					"self writeTextToOutputFile: 'Copy:'."
					"self writeTextToOutputFile: (keyAndValueArray at: i)."
					self writeTextToOutputFile: '#getCommitLog: Copy:'.
					ptr at: i put: (self convertCStringToOop: (revisionAndLogArray at: i)).
					self writeTextToOutputFile: '#getCommitLog: Finshed Copy:'.].
	
				"Free the allocated memory"
				0 to: arraySize - 1 do: [:i |
					self free: (revisionAndLogArray at: i)]].
	
	self cCode: 'free(target)'.
	self free: revisionAndLogArray.
	^ arrayOop! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/20/2008 16:12'!
svnGetHeadRevision: targetOop

	| target revision |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #revision declareC: 'int revision'.
	self primitive: 'svnGetHeadRevision' parameters: #(Oop ).
	
	self writeTextToOutputFile: '#svnGetHeadRevision:: Entered'.
	
	target := self cStringAllocatedOnHeapFromOop: targetOop.	
	"Call SVNWrapper function"
	self cCode: 'getHeadRevisionOf(target, &revision)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	"interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: revision)."
	^interpreterProxy integerObjectOf: revision! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rkrk 3/20/2008 14:01'!
svnGetPropertiesFrom: targetOop
"returns an array like #(key1 value1 key2 value2 ...)"
	
	| stringPtr err proplistItem revision truepath properties copiedOop |
	self export: true.
	self
		var: #err 			declareC: 'svn_error_t *err';
		var:  #revision 		declareC: 'svn_opt_revision_t revision';
		var: #truepath 		declareC: 'const char *truepath';
		var: #properties 		declareC: 'apr_array_header_t *properties';
		var: #proplistItem 	declareC: 'svn_client_proplist_item_t* proplistItem';
		var: #stringPtr 		declareC: 'char *stringPtr'.

	self primitive: 'svnGetPropertiesFrom' parameters: #(Oop).
	
	"stringPtr :=  interpreterProxy arrayValueOf: targetOop.
	copiedOop := self convertToOopCString: stringPtr ofSize: (interpreterProxy stSizeOf: targetOop).
	stringPtr :=  interpreterProxy arrayValueOf: copiedOop."
	stringPtr := self cStringFromOop: targetOop.
	
	self
		writeTextToOutputFile: 'Reading properties of:';
		writeTextToOutputFile: stringPtr;
		writeIntToOutputFile: (self strlen: stringPtr);
		writeIntToOutputFile: (interpreterProxy stSizeOf: targetOop).
	
	self
		cCode: 'revision.kind = svn_opt_revision_head';
		cCode: 'svn_opt_parse_path(&revision, &truepath, stringPtr, pool)'.
	
	err := self cCode: 'svn_client_proplist2(
		&properties, 		/* result: array of svn_client_proplist_item_t */
		truepath,		/* target */
		&revision, 		/* peg-revision */
		&revision, 		/* = peg-revision ???? */
		FALSE,			/* do not recurse */
		ctx, pool);'.
	err ifTrue: [self handleError: err].
	
	self
		writeTextToOutputFile: 'properties->nelts';
		writeIntToOutputFile: (self cCode: 'properties->nelts').

	"return of there are no properties"
	(self cCode: 'properties->nelts') = 0 ifTrue: [^ interpreterProxy
												instantiateClass: interpreterProxy classArray
												indexableSize: 0.].
	
	"If this is done recursively there can be more than one svn_client_proplist_item_t*
	in the result. But we want the properties per target, so assume properties size = 1"
	"self assert: (self cCode: 'properties->nelts') = 1."
		(self cCode: 'properties->nelts') = 1 ifFalse: [interpreterProxy success: false].
	
	"Take the first element"
	proplistItem := self cCode: '((svn_client_proplist_item_t**) properties->elts)[0]'. 
	"self cCode: 'apr_array_pop(properties)'.	<--- Iterate over properties????"
	
	"Iterate and fill the array"
	^ self squeakArrayFromAprHash: (self cCode: 'proplistItem->prop_hash').
! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/20/2008 13:12'!
svnInfoCbBaton: baton Target: target Info: info Pool: cbPool

	| arrayPtr |
	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton type: 'void *';
		var: #target type: 'const char *';
		var: #info type: 'const svn_info_t *';
		var: #cbPool type: 'apr_pool_t *'.
	self	var: #arrayPtr declareC: 'sqInt** arrayPtr'.
	
	self writeTextToOutputFile: (self cCode: 'info->URL').
	
	"1 to: 100000 do: [:i |
		interpreterProxy
			instantiateClass: interpreterProxy classString
			indexableSize: 50000]."
		
	arrayPtr := self cCoerce: baton to: 'sqInt **'.
	self putCString: 	(self cCode: 'info->repos_root_URL') 		in: arrayPtr at: 0.
	self putRevision: 	(self cCode: 'info->rev') 					in: arrayPtr at: 1.
	self putCString: 	(self cCode: 'info->repos_UUID') 			in: arrayPtr at: 2.
	self putRevision: 	(self cCode: 'info->last_changed_rev') 		in: arrayPtr at: 3.
	self putAprDate: 	(self cCode: 'info->last_changed_date') 	in: arrayPtr at: 4.
	self putCString: 	(self cCode: 'info->last_changed_author') 	in: arrayPtr at: 5.
	(self cCode: 'info->has_wc_info')
		ifTrue: [self writeTextToOutputFile: 'YES'.
			self putSchedule: 	(self cCode: 'info->schedule') in: arrayPtr at: 6.
				]
		ifFalse: [self writeTextToOutputFile: 'NO'.].
	"^ <#(repositoryUrl revision repositoryUUID lastChangedRev lastChangeDate lastChangedAuthor)>"
	^ self cCode: 'SVN_NO_ERROR'.
	

     " if (info->text_time)
        SVN_ERR(svn_cl__info_print_time(info->text_time, 
                                        _('Text Last Updated'), pool));
      
      if (info->prop_time)
        SVN_ERR(svn_cl__info_print_time(info->prop_time, 
                                        _('Properties Last Updated'), pool));
      
      if (info->checksum) 
        SVN_ERR(svn_cmdline_printf(pool, _('Checksum: %s\n'),
                                   info->checksum));
      
      if (info->conflict_old) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Previous Base File: %s\n'),
                                   svn_path_local_style(info->conflict_old,
                                                        pool)));
 
      if (info->conflict_wrk) 
        SVN_ERR(svn_cmdline_printf
                (pool, _('Conflict Previous Working File: %s\n'),
                 svn_path_local_style(info->conflict_wrk, pool)));
      
      if (info->conflict_new) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Current Base File: %s\n'),
                                   svn_path_local_style(info->conflict_new,
                                                        pool)));
 
      if (info->prejfile) 
        SVN_ERR(svn_cmdline_printf(pool, _('Conflict Properties File: %s\n'),
                                   svn_path_local_style(info->prejfile,
                                                        pool)));"! !

!SqueakSVNPlugin methodsFor: 'svn revert' stamp: 'rkrk 3/20/2008 12:51'!
svnRevertTargets: targets

	| numberOfTargets copiedTargets arrayPtr aTarget aTargetInPool err |
	self export: true.
	self
		var: #numberOfTargets declareC: 'int numberOfTargets';
		var: #copiedTargets 		declareC: 'char** copiedTargets';
		var: #arrayPtr 			declareC: 'int* arrayPtr';
		var: #aTarget			declareC: 'char* aTarget';
		var: #aTargetInPool 	declareC: 'char* aTargetInPool';
		var: #err 				declareC: 'svn_error_t *err'.
	self primitive: 'svnRevertTargets' parameters: #(Oop).

	self writeTextToOutputFile: 'Entered revert'.	

	
	self writeTextToOutputFile: 'Count targets'.
	numberOfTargets := interpreterProxy slotSizeOf: targets.
	
	self writeTextToOutputFile: 'Create apr_array'.
	copiedTargets := self cCode: 'apr_array_make (pool, numberOfTargets, sizeof (char*))'.

	self writeTextToOutputFile: 'Copy targets'.
	arrayPtr := interpreterProxy firstIndexableField: targets.
	0 to: numberOfTargets-1 do: [:i |
		aTarget := self cStringFromOop: (arrayPtr at: i).
		self writeTextToOutputFile: aTarget.
		aTargetInPool := self cCode: '(char*) apr_pstrdup (pool, aTarget)'.
		self cCode: 'APR_ARRAY_PUSH (copiedTargets, char*) = aTargetInPool'].
	
	self writeTextToOutputFile: 'Try to revert targets'.
	err := self cCode: 'svn_client_revert (
		copiedTargets,
		FALSE, 	/* no recurse */
		ctx,
		pool)'.
	err ifTrue: [self handleError: err].
		
	self writeTextToOutputFile: 'Leave revert'.
	^ targets! !

!SqueakSVNPlugin methodsFor: 'svn update' stamp: 'rkrk 3/20/2008 16:10'!
svnUpdateTargets: aOopCollectionOfOopTargets toRevisionByNumber: aNumberOop

	| targetsArray squeakStrings count cString revisionNumber |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self var: #revisionNumber declareC: 'long int revisionNumber'.
	self primitive: 'svnUpdateTargetsToRevisionByNumber:' parameters: #(Oop Integer ).
	
	"convert the collection"
	self writeTextToOutputFile: '#svnUpdateTargets:toRevisionByNumber: Entered'.
	
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"self cCode: 'revisionNumber = (long int) aNumberOop'."
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToRevisionByNumber( count, targetsArray , revisionNumber )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !

!SqueakSVNPlugin methodsFor: 'svn update' stamp: 'rkrk 3/20/2008 16:11'!
svnUpdateTargetsToHeadRevision: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self primitive: 'svnUpdateTargetsToHeadRevision' parameters: #(Oop ).
	
	"convert the collection"
	self writeTextToOutputFile: '#svnUpdateTargetsToHeadRevision: Entered'.
	
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToHeadRevision( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !
